/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the HighlightSubscriber type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HighlightSubscriber{}

// HighlightSubscriber struct for HighlightSubscriber
type HighlightSubscriber struct {
	Id string `json:"id"`
	HighlightId string `json:"highlight_id"`
	State string `json:"state"`
	Name string `json:"name"`
	PhotoUrl *string `json:"photo_url,omitempty"`
	Messenger Messenger `json:"messenger"`
	GatewayId *string `json:"gateway_id,omitempty"`
	ConversationId *string `json:"conversation_id,omitempty"`
	UserId *string `json:"user_id,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewHighlightSubscriber instantiates a new HighlightSubscriber object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHighlightSubscriber(id string, highlightId string, state string, name string, messenger Messenger, createdAt time.Time, updatedAt time.Time) *HighlightSubscriber {
	this := HighlightSubscriber{}
	this.Id = id
	this.HighlightId = highlightId
	this.State = state
	this.Name = name
	this.Messenger = messenger
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewHighlightSubscriberWithDefaults instantiates a new HighlightSubscriber object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHighlightSubscriberWithDefaults() *HighlightSubscriber {
	this := HighlightSubscriber{}
	return &this
}

// GetId returns the Id field value
func (o *HighlightSubscriber) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *HighlightSubscriber) SetId(v string) {
	o.Id = v
}

// GetHighlightId returns the HighlightId field value
func (o *HighlightSubscriber) GetHighlightId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.HighlightId
}

// GetHighlightIdOk returns a tuple with the HighlightId field value
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetHighlightIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.HighlightId, true
}

// SetHighlightId sets field value
func (o *HighlightSubscriber) SetHighlightId(v string) {
	o.HighlightId = v
}

// GetState returns the State field value
func (o *HighlightSubscriber) GetState() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.State
}

// GetStateOk returns a tuple with the State field value
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetStateOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.State, true
}

// SetState sets field value
func (o *HighlightSubscriber) SetState(v string) {
	o.State = v
}

// GetName returns the Name field value
func (o *HighlightSubscriber) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *HighlightSubscriber) SetName(v string) {
	o.Name = v
}

// GetPhotoUrl returns the PhotoUrl field value if set, zero value otherwise.
func (o *HighlightSubscriber) GetPhotoUrl() string {
	if o == nil || IsNil(o.PhotoUrl) {
		var ret string
		return ret
	}
	return *o.PhotoUrl
}

// GetPhotoUrlOk returns a tuple with the PhotoUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetPhotoUrlOk() (*string, bool) {
	if o == nil || IsNil(o.PhotoUrl) {
		return nil, false
	}
	return o.PhotoUrl, true
}

// HasPhotoUrl returns a boolean if a field has been set.
func (o *HighlightSubscriber) HasPhotoUrl() bool {
	if o != nil && !IsNil(o.PhotoUrl) {
		return true
	}

	return false
}

// SetPhotoUrl gets a reference to the given string and assigns it to the PhotoUrl field.
func (o *HighlightSubscriber) SetPhotoUrl(v string) {
	o.PhotoUrl = &v
}

// GetMessenger returns the Messenger field value
func (o *HighlightSubscriber) GetMessenger() Messenger {
	if o == nil {
		var ret Messenger
		return ret
	}

	return o.Messenger
}

// GetMessengerOk returns a tuple with the Messenger field value
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetMessengerOk() (*Messenger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Messenger, true
}

// SetMessenger sets field value
func (o *HighlightSubscriber) SetMessenger(v Messenger) {
	o.Messenger = v
}

// GetGatewayId returns the GatewayId field value if set, zero value otherwise.
func (o *HighlightSubscriber) GetGatewayId() string {
	if o == nil || IsNil(o.GatewayId) {
		var ret string
		return ret
	}
	return *o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetGatewayIdOk() (*string, bool) {
	if o == nil || IsNil(o.GatewayId) {
		return nil, false
	}
	return o.GatewayId, true
}

// HasGatewayId returns a boolean if a field has been set.
func (o *HighlightSubscriber) HasGatewayId() bool {
	if o != nil && !IsNil(o.GatewayId) {
		return true
	}

	return false
}

// SetGatewayId gets a reference to the given string and assigns it to the GatewayId field.
func (o *HighlightSubscriber) SetGatewayId(v string) {
	o.GatewayId = &v
}

// GetConversationId returns the ConversationId field value if set, zero value otherwise.
func (o *HighlightSubscriber) GetConversationId() string {
	if o == nil || IsNil(o.ConversationId) {
		var ret string
		return ret
	}
	return *o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetConversationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConversationId) {
		return nil, false
	}
	return o.ConversationId, true
}

// HasConversationId returns a boolean if a field has been set.
func (o *HighlightSubscriber) HasConversationId() bool {
	if o != nil && !IsNil(o.ConversationId) {
		return true
	}

	return false
}

// SetConversationId gets a reference to the given string and assigns it to the ConversationId field.
func (o *HighlightSubscriber) SetConversationId(v string) {
	o.ConversationId = &v
}

// GetUserId returns the UserId field value if set, zero value otherwise.
func (o *HighlightSubscriber) GetUserId() string {
	if o == nil || IsNil(o.UserId) {
		var ret string
		return ret
	}
	return *o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetUserIdOk() (*string, bool) {
	if o == nil || IsNil(o.UserId) {
		return nil, false
	}
	return o.UserId, true
}

// HasUserId returns a boolean if a field has been set.
func (o *HighlightSubscriber) HasUserId() bool {
	if o != nil && !IsNil(o.UserId) {
		return true
	}

	return false
}

// SetUserId gets a reference to the given string and assigns it to the UserId field.
func (o *HighlightSubscriber) SetUserId(v string) {
	o.UserId = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *HighlightSubscriber) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *HighlightSubscriber) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *HighlightSubscriber) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *HighlightSubscriber) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *HighlightSubscriber) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o HighlightSubscriber) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HighlightSubscriber) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["highlight_id"] = o.HighlightId
	toSerialize["state"] = o.State
	toSerialize["name"] = o.Name
	if !IsNil(o.PhotoUrl) {
		toSerialize["photo_url"] = o.PhotoUrl
	}
	toSerialize["messenger"] = o.Messenger
	if !IsNil(o.GatewayId) {
		toSerialize["gateway_id"] = o.GatewayId
	}
	if !IsNil(o.ConversationId) {
		toSerialize["conversation_id"] = o.ConversationId
	}
	if !IsNil(o.UserId) {
		toSerialize["user_id"] = o.UserId
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableHighlightSubscriber struct {
	value *HighlightSubscriber
	isSet bool
}

func (v NullableHighlightSubscriber) Get() *HighlightSubscriber {
	return v.value
}

func (v *NullableHighlightSubscriber) Set(val *HighlightSubscriber) {
	v.value = val
	v.isSet = true
}

func (v NullableHighlightSubscriber) IsSet() bool {
	return v.isSet
}

func (v *NullableHighlightSubscriber) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHighlightSubscriber(val *HighlightSubscriber) *NullableHighlightSubscriber {
	return &NullableHighlightSubscriber{value: val, isSet: true}
}

func (v NullableHighlightSubscriber) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHighlightSubscriber) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


